# EventCore
A plugin made to simplify hosting events/challenges

## Commands:
- /alivelist - eventcore.command.alivelist - Sends all alive players.
- /balrevive - eventcore.command.balrevive - Checks the revive balance of a player.
- /clearalive - eventcore.command.clearalive - Clears the inventory of alive players.
- /clearchat - eventcore.command.clearchat - Clears the chat of all players.
- /cleardead - eventcore.command.cleardead - Clears the inventory of dead players.
- /deadlist - eventcore.command.deadlist - Sends all dead players.
- /eventcore - eventcore.command.main - Main command
- /givealive - eventcore.command.givealive - Gives alive players items.
- /givedead - eventcore.command.givedead - Gives dead players items.
- /giverevive - eventcore.command.giverevive - Adds specified amount of revives to a player.
- /healalive - eventcore.command.healalive - Heals all alive players.
- /healdead - eventcore.command.healdead - Heals all dead players.
- /killalive - eventcore.command.killalive - Kills all alive players.
- /killdead - eventcore.command.killdead - Kills all dead players.
- /mutechat - eventcore.command.mutechat - Mutes the chat.
- /recentrev - eventcore.command.recentrev - Revives the recently killed alive players.
- /revive - eventcore.command.revive - Revives a specified player.
- /reviveall - eventcore.command.reviveall - Revives all players.
- /revivelate - eventcore.command.revivelate - Revives all dead players.
- /setrevive - eventcore.command.setrevive - Sets a player's revive balance to the specified amount.
- /takerevive - eventcore.command.takerevive - Removes specified amount of revives to a player.
- /togglerevive - eventcore.command.togglerevive - Toggles the use of revive tokens.
- /tpalive - eventcore.command.tpalive - Teleports all alive players.
- /tpdead - eventcore.command.tpdead - Teleports all dead players.
- /unrevive - eventcore.command.unrevive - Unrevives an alive player.
- /userevive - eventcore.command.userevive - Uses a revive if the sender has enough revives.
- /visibility - eventcore.visibility.use - Hides players.

## Permissions:
- eventcore.visibility.staffbypass - Lets players see the permission holder during hide staff.
- eventcore.visibility.all - Use '/visibility all'.
- eventcore.visibility.staff - Use '/visibility staff'.
- eventcore.visibility.off - Use '/visibility off'.
- eventcore.reviveall.bypass - Won't revive the permission holder in a revive all..


## Features:
- Customizable Messages
- bStats
- Dead and alive checker
- PlaceholderAPI support
  - %eventcore_alive% - Size of all alive players
  - %eventcore_dead% - Size of all dead players
  - %eventcore_status% - The status of the player (dead or alive)
  - %eventcore_revive% - The amount of revives the player has
  - %eventcore_revives% - Alias of %eventcore_revive%
  - %eventcore_mutechat% - True if chat is muted, otherwise false
  - %eventcore_visibility% - The state of visibility of the player
- Skript Support
- and more!

For support, join my discord [here](https://discord.gg/33g92zJnPC)

# Links
[SpigotMC](https://www.spigotmc.org/resources/eventcore-plugin.113142/) |
[Modrinth](https://modrinth.com/plugin/event) |
[bStats](https://bstats.org/plugin/bukkit/EventCore/19718) |
[PAPI Wiki](https://github.com/PlaceholderAPI/PlaceholderAPI/wiki/Placeholders#eventcore) |
[Source Code](https://github.com/aabssmc/EventCore)
